unit untMain;

interface

uses
  Windows, Menus, Dialogs, Controls, StdCtrls, ExtCtrls, Forms, ComCtrls,
  Classes, SysUtils;

type
  TfrmMain = class(TForm)
    Indicator: TProgressBar;
    txtEditKey: TEdit;
    Btn: TButton;
    lblText: TLabel;
    dlgOpenFile: TOpenDialog;
    mnuMain: TMainMenu;
    mnuFile: TMenuItem;
    mnuSelFile: TMenuItem;
    mnuExit: TMenuItem;
    mnu1: TMenuItem;
    SelectAct: TRadioGroup;
    btnCancel: TButton;
    procedure FormCreate(Sender: TObject);
    procedure dlgOpenFileCanClose(Sender: TObject;
      var CanClose: Boolean);
    procedure txtEditKeyChange(Sender: TObject);
    procedure BtnClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure mnuSelFileClick(Sender: TObject);
    procedure SelectActClick(Sender: TObject);
    procedure mnuHelpClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

//   
{$R *.DFM}
Type
  //      
  FileType = File Of Char;
//    / 
Var
    FileCoded : FileType; //  
    FileTemp : FileType;  //  

Procedure Coding_Decoding;

//  
Procedure Coding(intLStep : Byte; intHundred : Cardinal);
Var
  intFilePoint : Cardinal;   //    
  chrSymbol : Char;          //    
  intCode : Byte;            //     
Begin
  intFilePoint := 0;
  While Not(Eof(FileCoded)) Do
    Begin
      //   ,    Windows
      Application.ProcessMessages;
      //       ""
      If (frmMain.Tag = 1) Or (frmMain.Tag = 2) Then
        Exit;
      //     
      Read(FileCoded,chrSymbol);
      //   
      intCode := Ord(chrSymbol);
      //   
      intCode := intCode + intLStep;
      //  
      chrSymbol := Chr(intCode);
      //     
      Write(FileTemp,chrSymbol);
      //    
      Inc(intFilePoint);
      //     
      If intFilePoint Mod intHundred = 0 Then
        frmMain.Indicator.StepIt;
    End
End;

//  
Procedure DeCoding(intLStep : Byte; intHundred : Cardinal);
Var
  intFilePoint : Cardinal;   //    
  chrSymbol : Char;          //    
  intCode : Byte;            //     
Begin
  intFilePoint := 0;
  While Not(Eof(FileCoded)) Do
    Begin
      //   ,    Windows
      Application.ProcessMessages;
      //       ""
      If (frmMain.Tag = 1) Or (frmMain.Tag = 2) Then
        Exit;
      //     
      Read(FileCoded,chrSymbol);
      //   
      intCode := Ord(chrSymbol);
      //   
      intCode := intCode - intLStep;
      //  
      chrSymbol := Chr(intCode);
      //     
      Write(FileTemp,chrSymbol);
      //    
      Inc(intFilePoint);
      //     
      If intFilePoint Mod intHundred = 0 Then
        frmMain.Indicator.StepIt;
    End
End;

//    - 
Var
  intStep : Byte;         //       
  i : Byte;               //     
  FName : TFileName;      //   (  )
  intHundred : Cardinal;
  bytAttr : Byte;         //   
  binReadOnly : Boolean;  //   
  binArchive : Boolean;   // 
  binHidden : Boolean;    // 
  binSystem : Boolean;    // 
Begin
  //     
  binReadOnly := False;
  binArchive := False;
  binHidden := False;
  binSystem := False;
  //    
  bytAttr := FileGetAttr(frmMain.dlgOpenFile.FileName);
  //     
  If bytAttr and faReadOnly <> 0 Then
    binReadOnly := True;
  If bytAttr and faArchive <> 0 Then
    binArchive := True;
  If bytAttr and faHidden <> 0 Then
    binHidden := True;
  If bytAttr and faSysFile <> 0 Then
    binSystem := True;
  //       
  FileSetAttr(frmMain.dlgOpenFile.FileName,0);
  intStep := 0;
  For i := 1 To Length(frmMain.txtEditKey.Text) Do
    intStep := intStep + Ord(frmMain.txtEditKey.Text[i]);
  //      
  AssignFile(FileCoded,frmMain.dlgOpenFile.FileName);
  AssignFile(FileTemp,frmMain.dlgOpenFile.FileName + '.tmp');
  //      
  Reset(FileCoded);
  //       (  )
  ReWrite(FileTemp);
  //   ,       / 
  If FileSize(FileCoded) >= 26 Then
    Begin
      frmMain.Indicator.Max := 26;
      intHundred := FileSize(FileCoded) Div frmMain.Indicator.Max
    End
  Else
    Begin
      frmMain.Indicator.Max := FileSize(FileCoded);
      intHundred := FileSize(FileCoded) Div frmMain.Indicator.Max
    End;
  //           
  If Length(frmMain.dlgOpenFile.FileName) > 23 Then
    FName := '...' + Copy(frmMain.dlgOpenFile.FileName,
                          Length(frmMain.dlgOpenFile.FileName) - 22,23)
  Else
    FName := frmMain.dlgOpenFile.FileName;
  //  /     
  If frmMain.SelectAct.ItemIndex = 0 Then
    Begin
      frmMain.Caption := ': ' + FName;
      Coding(intStep,intHundred) //  
    End
  Else
    Begin
      frmMain.Caption := ': ' + FName;
      Decoding(intStep,intHundred)  //  
    End;
  //     
  CloseFile(FileCoded);
  CloseFile(FileTemp);
  //       ""
  If (frmMain.Tag = 1) Or (frmMain.Tag = 2) Then
    Begin
      //   
      DeleteFile(frmMain.dlgOpenFile.FileName + '.tmp');
      //   ,   
      If frmMain.Tag = 2 Then
        Application.Terminate
    End
  Else
    Begin
      //   
      DeleteFile(frmMain.dlgOpenFile.FileName);
      //       (  )
      RenameFile(frmMain.dlgOpenFile.FileName + '.tmp',
      frmMain.dlgOpenFile.FileName)
    End;
  //      
  If binReadOnly Then
    FileSetAttr(frmMain.dlgOpenFile.FileName,faReadOnly);
  bytAttr := FileGetAttr(frmMain.dlgOpenFile.FileName);
  If binArchive Then
    FileSetAttr(frmMain.dlgOpenFile.FileName,bytAttr+faArchive);
  bytAttr := FileGetAttr(frmMain.dlgOpenFile.FileName);
  If binHidden Then
    FileSetAttr(frmMain.dlgOpenFile.FileName,bytAttr+faHidden);
  bytAttr := FileGetAttr(frmMain.dlgOpenFile.FileName);
  If binSystem Then
    FileSetAttr(frmMain.dlgOpenFile.FileName,bytAttr+faSysFile);
  //     / 
  frmMain.Indicator.Position := 0
End;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  //     ""
  SelectAct.ItemIndex := 0
end;

procedure TfrmMain.dlgOpenFileCanClose(Sender: TObject;
  var CanClose: Boolean);
begin
  //        
  txtEditKey.Enabled := True; //   
  Btn.Enabled := True       //  /
end;

procedure TfrmMain.txtEditKeyChange(Sender: TObject);
begin
  //   ,     ( )
  If txtEditKey.Text = '' Then
    Btn.Enabled := False  // /  
  Else
    Btn.Enabled := True   // / 
end;

procedure TfrmMain.BtnClick(Sender: TObject);
begin
  //    ""   
  Tag := 0;
  //   ""
  btnCancel.Enabled := True;
  //       
  mnuSelFile.Enabled := False;  //   " "
  SelectAct.Enabled := False; //  
  txtEditKey.Enabled := False;   //   
  Btn.Enabled := False;        //  /
  //     - 
  Coding_Decoding;
  //    (    )
  mnuSelFile.Enabled := True;   //   " "
  SelectAct.Enabled := True;  //  
  //   ""
  btnCancel.Enabled := False;
  //     
  frmMain.Caption := ' '
end;

procedure TfrmMain.mnuExitClick(Sender: TObject);
begin
  //    
  Close
end;

procedure TfrmMain.mnuSelFileClick(Sender: TObject);
begin
  //   " "
  dlgOpenFile.Execute
end;

procedure TfrmMain.SelectActClick(Sender: TObject);
begin
  //     
  If SelectAct.ItemIndex = 0 Then
    Begin
      Btn.Caption := ' ';
      lblText.Caption := '    '
    End
  Else
    Begin
      Btn.Caption := ' ';
      lblText.Caption := '    '
    End
end;

procedure TfrmMain.mnuHelpClick(Sender: TObject);
begin
  //    (1- )
  WinHelp(frmMain.Handle,'Cryptographer.HLP',HELP_CONTEXT,1)
end;

procedure TfrmMain.btnCancelClick(Sender: TObject);
begin
  // ,   /   
  Tag := 1
end;

end.
